//
//  Cat.swift
//  NyanFat
//
//  Created by 131e55 on 1/24/15.
//  Copyright (c) 2015 GGJ2015Team11. All rights reserved.
//

import SpriteKit

let sharedCatRankUpScore = [0, 500, 1500]
let sharedCatMouthDistance = [30, 70, 130]
var sharedCurrentCatMouthDistance = 0

class Cat: SKSpriteNode {
    var score = 0          // ゲームのスコア
    var rank = 0           // スコアによって決まるランク, ランクによって太った猫の画像へ変える

    override init(texture: SKTexture!, color: UIColor!, size: CGSize) {
        super.init(texture: texture, color: SKColor.clearColor(), size: size)
    }

    convenience override init() {
        let texture = SKTexture(imageNamed: "nyan_0")
        let size = texture.size()
        self.init(texture: texture, color: SKColor.clearColor(), size: size)
    }

    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    func initialize() {
        self.score = 0
        self.rank = 0
        let imageNamed = "nyan_0"
        let texture = SKTexture(imageNamed: imageNamed)
        self.texture = texture
        self.size = texture.size()
    }

    func addScore(score: Int) {
        self.score += score
        if sharedCatRankUpScore.count - 1 > self.rank {
            if sharedCatRankUpScore[self.rank + 1] <= self.score {
                self.rank++
                let imageNamed = "nyan_" + String(self.rank)
                let texture = SKTexture(imageNamed: imageNamed)
                self.texture = texture
                self.size = texture.size()
                sharedCurrentCatMouthDistance = sharedCatMouthDistance[self.rank]
            }
        }
    }
}
