//
//  GameViewController.swift
//  NyanFat
//
//  Created by 131e55 on 1/24/15.
//  Copyright (c) 2015 GGJ2015Team11. All rights reserved.
//

import UIKit
import SpriteKit
import AVFoundation

class GameViewController: UIViewController, GameSceneDelegate {
    var score: Int = 0
    var audioPlayer:AVAudioPlayer = AVAudioPlayer();
    var sound_data:NSURL = NSURL();

    private var _gameScene: GameScene!

    override func viewDidLoad() {
        super.viewDidLoad()

        // Configure the view.
        let skView = self.view as SKView
        
        /* Sprite Kit applies additional optimizations to improve rendering performance */
        skView.ignoresSiblingOrder = true
        
        /* Set the scale mode to scale to fit the window */
        self._gameScene = GameScene()
        self._gameScene.scaleMode = .AspectFill
        self._gameScene.gameDelegate = self
        
        skView.presentScene(self._gameScene)
        
        self.playBGM()
    }

    override func viewWillAppear(animated: Bool) {
        self._gameScene.gameStart()
        self.viewDidLoad()        
    }

    func moveToResult() {
        self.performSegueWithIdentifier("GameToResultSegue", sender: nil)
    }
    
    override func shouldAutorotate() -> Bool {
        return true
    }

    override func supportedInterfaceOrientations() -> Int {
        if UIDevice.currentDevice().userInterfaceIdiom == .Phone {
            return Int(UIInterfaceOrientationMask.AllButUpsideDown.rawValue)
        } else {
            return Int(UIInterfaceOrientationMask.All.rawValue)
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Release any cached data, images, etc that aren't in use.
    }

    override func prefersStatusBarHidden() -> Bool {
        return true
    }

    func gameEnd(score:Int) {
        self.score = score
        self.moveToResult()
    }
    
    // 値の受け渡し
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        let resultViewController = segue.destinationViewController as ResultViewController
        resultViewController.score = self.score
    }
    
    func playBGM() {
        var sound_data = NSURL(fileURLWithPath: NSBundle.mainBundle().pathForResource("BGM", ofType: "mp3")!);
        self.audioPlayer = AVAudioPlayer(contentsOfURL: sound_data, error: nil);
        self.audioPlayer.numberOfLoops = -1
        self.audioPlayer.prepareToPlay()
        self.audioPlayer.play()
    }
}
